# -*- python -*-
# $RCSfile: activelistparamwidget.py,v $
# $Revision: 1.1 $
# $Author: redwing $
# $Date: 2005/05/13 19:29:24 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Special widget for boundary modifier parameters -- has some
# intelligence to know whether its result should be a
# PointBoundaryModifier or an EdgeBoundaryModifier.

from oof2.common.IO.GUI import regclassfactory
from oof2.common.IO import parameter



class ActiveListParamWidget(regclassfactory.RegisteredClassFactory):
    def __init__(self, registry, obj=None, title=None,
                 callback=None, fill=0, expand=0, scope=None,
                 activelist = [],
                 widgetdict={},
                 *args, **kwargs):
        self.activelist = activelist
        regclassfactory.RegisteredClassFactory.__init__(
            self, registry, obj=obj, title=title, callback=callback,
            fill=fill, expand=expand, scope=scope, widgetdict=widgetdict,
            *args, **kwargs)




    def includeRegistration(self, registration):
        return registration.subclass in self.activelist


def _makeALPWidget(self, scope=None):
    return ActiveListParamWidget(self.registry,
                                 self.value,
                                 scope=scope,
                                 widgetdict=regclassfactory._getWidgetDict(self),
                                 activelist=self.activelist

                                 )

parameter.ActiveListRegisteredParameter.makeWidget = _makeALPWidget
