# -*- python -*-
# $RCSfile: gtkutils.py,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2005/05/13 18:43:50 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from gtk import *
from oof2.common import debug

# Make widget dest have the same size as widget source.  Since widgets
# get their sizes from their children, recursively set the children's
# sizes too.  This only works if both source and dest have the same
# structure, of course.  It's meant to be used when cloning windows.
# This doesn't work completely correctly.  Perhaps the allocation is
# not the right thing to be copying?

def copyWidgetSizes(source, dest):
    debug.mainthreadTest()
    w, h = source.get_allocation()[2:4]
    dest.set_usize(w, h)
    if isinstance(source, GtkContainer) and isinstance(dest, GtkContainer):
        for s,d in zip(source.children(), dest.children()):
            copyWidgetSizes(s, d)
