// -*- C++ -*-
// $RCSfile: iso.h,v $
// $Revision: 1.12 $
// $Author: langer $
// $Date: 2004/03/19 19:21:30 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef ISOELASTICITY_H
#define ISOELASTICITY_H

#include <Python.h>
#include "engine/property/elasticity/elasticity.h"
#include "engine/property/elasticity/cijkl.h"
#include <string>

class IsoElasticityProp : public Elasticity {
private:
  static const std::string nameplate;
  Cijkl c_ijkl;
public:
  IsoElasticityProp(PyObject *registry, const std::string &name,
		    Cijkl* c);
  virtual ~IsoElasticityProp() {}
  virtual void precompute();
  Cijkl *cijkl_pointer() { return &c_ijkl; }
protected:
  virtual const Cijkl cijkl(const FEMesh*, const Element*, 
			    const MasterPosition&) const {
    return c_ijkl; }
};

#endif
