# -*- python -*-
# $RCSfile: massdensity_.py,v $
# $Revision: 1.20 $
# $Author: langer $
# $Date: 2005/05/13 18:44:16 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from oof2.common.IO import parameter
from oof2.engine import problem

import types
from oof2.SWIG.common import devel

if devel.devel():
    PropertyRegistration(
        'Mechanical:MassDensity:ConstantMassDensity', MassDensityProp,
        "oof2.SWIG.engine.property.massdensity.massdensity",100,
        [parameter.FloatParameter('rho', 0.0, tip="Mass density")],
        fluxes=[problem.Stress],
        propertyType="MassDensity")

# Repr refers to registered name, not class name.    
def _MassDensity___repr__(self):
    return "ConstantMassDensity(name='%s', rho=%s)" % \
           (self.name(), `self.fetch_value()`)

MassDensityPropPtr.__repr__ = _MassDensity___repr__
